<div class="macro">
  <h3>Predefined Filters</h3>
  <button mat-raised-button (click)="applyMacro('LowTemperatureDiamond')">LTD</button>
  <button mat-raised-button (click)="applyMacro('Painite')">Painite</button>
  <button mat-raised-button (click)="applyMacro('Tritium')">Tritium</button>
  <button mat-raised-button (click)="applyMacro('Opal')">Void Opal</button>
  <button mat-raised-button (click)="applyMacro('Haz')">Haz Res</button>
  <hr>
</div>
<div class="filters">
  <mat-form-field class="filter referenceSystem">
    <input type="text" placeholder="Reference System" value="Sol" matInput (keyup)="searchSystems(referenceSystem.value)" [matAutocomplete]="auto" #referenceSystem>
    <mat-autocomplete #auto="matAutocomplete" (optionSelected)="getOverlapsNearSystem($event.option.value)">
      <mat-option *ngFor="let option of filteredSystems$ | async" [value]="option.systemName">
        {{option.systemName}}
      </mat-option>
    </mat-autocomplete>
  </mat-form-field>
  <mat-form-field class="filter dataSourceFilter">
    <mat-label>Filter</mat-label>
    <input matInput (keyup)="applyFilter(filter)" placeholder="Tritium2" [(ngModel)]="filter">
  </mat-form-field>
  <button mat-stroked-button (click)="toggleDetail()">{{showDetail ? 'Hide' : 'Show'}} detail</button>
</div>

<div class="example-container mat-elevation-z8">
  <table mat-table [dataSource]="dataSource" multiTemplateDataRows matSort>

    <ng-container matColumnDef="overlapID">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> ID </th>
      <td mat-cell *matCellDef="let element"> {{element.overlapID}} </td>
    </ng-container>
    <ng-container matColumnDef="systemDistance">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Distance </th>
      <td mat-cell *matCellDef="let element"> {{element.systemDistance | number:'.2-2'}} Ly </td>
    </ng-container>
    <ng-container matColumnDef="bodyDistanceToStar">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Distance to Star </th>
      <td mat-cell *matCellDef="let element"> {{element.bodyDistanceToStar}} ls </td>
    </ng-container>
    <ng-container matColumnDef="bodyName">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Body </th>
      <td mat-cell *matCellDef="let element"> {{element.bodyName}} </td>
    </ng-container>
    <ng-container matColumnDef="bodyReserve">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Reserve </th>
      <td mat-cell *matCellDef="let element"> {{element.bodyReserve}} </td>
    </ng-container>
    <ng-container matColumnDef="bodyRingTypes">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Ring Types </th>
      <td mat-cell *matCellDef="let element"> {{element.bodyRingTypes}} </td>
    </ng-container>
    <ng-container matColumnDef="commodity">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Commodity </th>
      <td mat-cell *matCellDef="let element"> {{element.commodity}} </td>
    </ng-container>
    <ng-container matColumnDef="reporter">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Reporter </th>
      <td mat-cell *matCellDef="let element"> {{element.reporter}} </td>
    </ng-container>
    <ng-container matColumnDef="createdAt">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Reported </th>
      <td mat-cell *matCellDef="let element"> {{element.createdAt | date:'full'}} </td>
    </ng-container>
    <ng-container matColumnDef="approved">
      <th mat-header-cell *matHeaderCellDef mat-sort-header> Status </th>
      <td mat-cell *matCellDef="let element" [style.color]="element.approvedColor"> {{element.approved ? 'Approved' : 'Pending'}} </td>
    </ng-container>

    <ng-container matColumnDef="expandedDetail">
      <td mat-cell *matCellDef="let row" [attr.colspan]="displayedColumns.length">
        <div class="overlap-detail"
             [@detailExpand]="row === expandedElement ? 'expanded' : 'collapsed'">
          <markdown>{{row.description}}</markdown>
        </div>
      </td>
    </ng-container>

    <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
    <tr mat-row *matRowDef="let row; columns: displayedColumns;"
        class="overlap-row"
        [class.example-expanded-row]="expandedElement === row"
        (click)="expandedElement = expandedElement === row ? null : row">
    </tr>
    <tr mat-row *matRowDef="let row; columns: ['expandedDetail']" class="detail-row"></tr>

    <tr class="mat-row" *matNoDataRow>
      <td class="mat-cell" colspan="4">No data matching the filter "{{filter}}"</td>
    </tr>
  </table>

  <mat-paginator [pageSizeOptions]="[5, 10, 25, 100]"></mat-paginator>
</div>
